<?php
/*
不可視スレッド一覧を出力するRSS

使い方
invisible.php?host/bbs

例
ニュー速VIP invisible.php?ex17.2ch.net/news4vip

出力
description:不可視数/ディレクトリに存在するdat数
title:スレッドのkey
link等:スレッドのURL/l50
dc:date:スレッドのBirthday

注意
hostやbbsに/が入る板には対応していない
*/

// 当然だがディレクトリ→subject.txtの順でないと不可視でないスレッドも入ってしまう
// と思ったけど同時に取得しないとだめでないだろうか

// 変数の初期化をしないと怒られるので
$item = '';

// hostとbbsを取得
$bbsinfo = explode('/', $_SERVER['QUERY_STRING']);
if ($bbsinfo[0] && $bbsinfo[1]) {
    $host = $bbsinfo[0];    // host
    $bbs  = $bbsinfo[1];    // bbs

    // datディレクトリからの取得
    $file = file_get_contents('http://' . $_SERVER['QUERY_STRING'] . '/dat/', FALSE);
    preg_match_all('/<a href="\d+\.dat">(\d+)\.dat<\/a>/',$file,$directory);

    // subject.txtからの取得
    $file = @file_get_contents('http://' . $_SERVER['QUERY_STRING'] . '/subject.txt', FALSE);
    preg_match_all('/(.+)\.dat<>.+? \(\d+\)/',$file,$subject);

    // 差分を取得
    $main = array_intersect(array_diff($directory[1],$subject[1]), $directory[1]);

    // スレッド数を取得
    $count['diff'] = count($main);          // 不可視数
    $count['dir']  = count($directory[1]);  // 全dat数

    foreach ($main as $key){
    	$birthday = date('y/m/d G:i:s', $key);                  //スレ立て日時
    	$url = "http://{$host}/test/read.cgi/{$bbs}/{$key}/l50"; //URL
    	$item .= <<<EOP
<item rdf:about="{$url}">
	<title>{$key}</title>
	<link>{$url}</link>
	<dc:date>{$birthday}</dc:date>
</item>
EOP;
    }
    $description = "{$count['diff']}/{$count['dir']}";
} else {
    $description = 'エラー:クエリが異常です';
}

echo <<<EOP
<?xml version="1.0" encoding="UTF-8"?>
<rdf:RDF
xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
xmlns="http://purl.org/rss/1.0/"
xmlns:content="http://purl.org/rss/1.0/modules/content/"
xmlns:taxo="http://purl.org/rss/1.0/modules/taxonomy/"
xmlns:dc="http://purl.org/dc/elements/1.1/"
xmlns:syn="http://purl.org/rss/1.0/modules/syndication/"
xmlns:admin="http://webns.net/mvcb/"
>
<channel>
	<title>不可視スレッド</title>
	<link>http://{$_SERVER['QUERY_STRING']}/dat/</link>
	<dc:language>ja</dc:language>
	<description>{$description}</description>
</channel>

{$item}

</rdf:RDF>
EOP;
